/**
 * \file
 *
 * \brief SSD1306 OLED\ײ
 *
 * 쌠 (c) 2012-2015 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */

#ifndef SSD1306_H_INCLUDED
#define SSD1306_H_INCLUDED
#include <avr/io.h>
#include <util/delay.h>
#include <stdbool.h>

// OLEĎ`Ԑݒ̧
#include "conf_ssd1306.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup ssd1306_oled_controller_group SSD1306 OLEDײ
 *
 * 4SPIʂSSD1306 OLEDp̒ײނłBOLEDɑ
 * 鏉Əݗp̊{IȊ֐񋟂܂Bʰ޳OLED
 * ֐̎gp@܂B
 *
 * \ްOɕ̪OLED\ݒ肷\ref ssd1306_init() 
 * ĂłBǂ̲̪gp̂`̂\ref conf_ssd1306.h
 * Ɩtꂽ̧قKvƂ܂B葽̏ɂĂͲ̪I
 * BāA\ref SSD1306_DC_PIN, \ref SSD1306_CS_PIN, \ref SSD13
 * 06_RES_PINƕ\\ref SSD1306_CLOCK_SPEED̒`KvłB
 *
 * \warning ײނ͍ē\ł͂ȂAǉ̕یȂɊ荞ݏٰݓŎg
 *			p邱Ƃ͂ł܂B
 *
 *
 * \ref conf_ssd1306.ḩق͈ȉ̂悤Ɍ܂B
 * \code
	 // ̪I
	 #define SSD1306_SPI			SERCOM2

	 #define SSD1306_CLOCK_SPEED	1000000

	 #define SSD1306_DC_PIN			PIN_PB24
	 #define SSD1306_CS_PIN			PIN_PB27
	 #define SSD1306_RES_PIN		PIN_PA17
\endcode
 *
 * \section dependencies ˑ
 * ײނ͈ȉ̒PʕɈˑ܂B
 * - \ref asfdoc_sam0_port_group o͐p
 * - \ref asfdoc_sam0_system_group @\̂߂̼ ۯx擾p
 * - \ref asfdoc_sam0_sercom_spi_group OLEDƂ̒ʐMp
 * - \ref asfdoc_sam0_sercom_spi_group OLEDƂ̒ʐMp
 * @{
 */

//! \name {ߒ`
//@{
#define SSD1306_CMD_COL_ADD_SET_LSB(column)			(0x00 | (column))
#define SSD1306_CMD_COL_ADD_SET_MSB(column)			(0x10 | (column))
#define SSD1306_CMD_SET_MEMORY_ADDRESSING_MODE		0x20
#define SSD1306_CMD_SET_COLUMN_ADDRESS				0x21
#define SSD1306_CMD_SET_PAGE_ADDRESS				0x22
#define SSD1306_CMD_SET_DISPLAY_START_LINE(line)	(0x40 | (line))
#define SSD1306_CMD_SET_CONTRAST_CONTROL_FOR_BANK0	0x81
#define SSD1306_CMD_SET_CHARGE_PUMP_SETTING			0x8D
#define SSD1306_CMD_SET_SEGMENT_RE_MAP_COL0_SEG0	0xA0
#define SSD1306_CMD_SET_SEGMENT_RE_MAP_COL127_SEG0	0xA1
#define SSD1306_CMD_ENTIRE_DISPLAY_AND_GDDRAM_ON	0xA4
#define SSD1306_CMD_ENTIRE_DISPLAY_ON				0xA5
#define SSD1306_CMD_SET_NORMAL_DISPLAY				0xA6
#define SSD1306_CMD_SET_INVERSE_DISPLAY				0xA7
#define SSD1306_CMD_SET_MULTIPLEX_RATIO				0xA8
#define SSD1306_CMD_SET_DISPLAY_ON					0xAF
#define SSD1306_CMD_SET_DISPLAY_OFF					0xAE
#define SSD1306_CMD_SET_PAGE_START_ADDRESS(page)	(0xB0 | (page))
#define SSD1306_CMD_SET_COM_OUTPUT_SCAN_UP			0xC0
#define SSD1306_CMD_SET_COM_OUTPUT_SCAN_DOWN		0xC8
#define SSD1306_CMD_SET_DISPLAY_OFFSET				0xD3
#define SSD1306_CMD_SET_DISPLAY_CLOCK_DIVIDE_RATIO	0xD5
#define SSD1306_CMD_SET_PRE_CHARGE_PERIOD			0xD9
#define SSD1306_CMD_SET_COM_PINS					0xDA
#define SSD1306_CMD_SET_VCOMH_DESELECT_LEVEL		0xDB
#define SSD1306_CMD_NOP								0xE3
//@}
//! \name ̨ߒ`
//@{
#define SSD1306_CMD_SCROLL_H_RIGHT					0x26
#define SSD1306_CMD_SCROLL_H_LEFT					0x27
#define SSD1306_CMD_CONTINUOUS_SCROLL_V_AND_H_RIGHT	0x29
#define SSD1306_CMD_CONTINUOUS_SCROLL_V_AND_H_LEFT	0x2A
#define SSD1306_CMD_DEACTIVATE_SCROLL				0x2E
#define SSD1306_CMD_ACTIVATE_SCROLL					0x2F
#define SSD1306_CMD_SET_VERTICAL_SCROLL_AREA		0xA3
//@}

/**
 * \name ̪I
 *
 * OLED͒ƕ̗`ԂxA͈قȂSAMӋ@\gp
 * ̪鑽̉\ȕ@邱ƂӖ܂BقȂ`gp
 * Ċe̪IԂƂł܂BײނSPI呕ugp钼ʐM
 * x܂B
 *
 * \note ݂ײނ͒񓮍삾x܂B
 */
/** @{@} */

extern struct spi_module ssd1306_master;
extern struct spi_slave_inst ssd1306_slave;

//! \name OLEDǂݏ֐
//@{
void ssd1306_write_command(uint8_t command);

void ssd1306_write_data(uint8_t data);

/**
 * \brief 킩ްǂݍ
 *
 * \note ͒񓮍ł̓ǂݍ݂x܂B
 *
 * \retval 킩ǂ܂ꂽ8ޯ ް
 */
static inline uint8_t ssd1306_read_data(void)
{
	return 0;
}

/**
 * \brief 킩ԓǂݍ
 *
 * \note ͒񓮍ł̓ǂݍ݂x܂B
 *
 * \retval 킩ǂ܂ꂽ8ޯĂ̏Ԓl
 */
static inline uint8_t ssd1306_get_status(void)
{
	return 0;
}
//@}

//! \name OLEDؾ
//@{

/**
 * \brief OLEDʰ޳ ؾĂs
 *
 * ̊֐ؾ ݂Lowɐݒ肷邱ƂɂOLEDؾĂ܂B
 */
static inline void ssd1306_hard_reset(void)
{
	PORTD &= ~SSD1306_RES_PIN;
	_delay_us(10);
	PORTD |= SSD1306_RES_PIN;
	_delay_us(10);
	
	//port_pin_set_output_level(SSD1306_RES_PIN, false);
	//delay_cycles(delay_10us); // At lest 10us
	//port_pin_set_output_level(SSD1306_RES_PIN, true);
	//delay_cycles(delay_10us); // At lest 10us
}
//@}

//! \name x~
//@{
/**
 * \brief OLEDx~
 */
static inline void ssd1306_sleep_enable(void)
{
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_OFF);
}

/**
 * \brief OLEDx~֎~
 */
static inline void ssd1306_sleep_disable(void)
{
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_ON);
}
//@}

//! \name OLEDɑ΂ıڽ\ݒ
//@{
/**
 * \brief \RAMɌ݂߰ނݒ
 *
 * ̎dg݂͕\̑SĂ̈ʒu̱񋟂̂ŁA̖߂͒ʏAڽ
 * ̌`Ԑݒ肪܂B
 *
 * \param address		߰ ڽ
 */
static inline void ssd1306_set_page_address(uint8_t address)
{
	address &= 0x0F;	// ڽ4ޯ(8߰ނ)ȂƂmɂĂB
	ssd1306_write_command(SSD1306_CMD_SET_PAGE_START_ADDRESS(address));
}

/**
 * \brief \RAMɌ݂̗ݒ
 *
 * \param address		ڽ
 */
static inline void ssd1306_set_column_address(uint8_t address)
{
	address &= 0x7F;	// ڽ7ޯĂł邱ƂmɂĂB
	ssd1306_write_command(SSD1306_CMD_COL_ADD_SET_MSB(address >> 4));
	ssd1306_write_command(SSD1306_CMD_COL_ADD_SET_LSB(address & 0x0F));
}

/**
 * \brief \ɕ`Jnڽݒ
 *
 * ̊֐͂ǂ̐OLEDɑ΂ĕ`Jnłׂݒ肵܂B
 */
static inline void ssd1306_set_display_start_line_address(uint8_t address)
{
	address &= 0x3F;	// ڽ6ޯĂł邱ƂmɂĂB
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_START_LINE(address));
}
//@}

//! \name \ʰ޳
//@{
/**
 * \brief OLED\ON؂ւ
 *
 * ̊֐OLEDONɐ؂ւ܂B
 */
static inline void ssd1306_display_on(void)
{
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_ON);
}

/**
 * \brief OLED\OFF؂ւ
 *
 * ̊֐OLEDOFFɐ؂ւ܂B
 */
static inline void ssd1306_display_off(void)
{
	ssd1306_write_command(SSD1306_CMD_SET_DISPLAY_OFF);
}

/**
 * \brief OLED̔ZWقݒ
 *
 * \param	contrast	0`0xFFԂ̐l
 *
 * \retval	contrast	OLEDɏꂽZWl
 */
static inline uint8_t ssd1306_set_contrast(uint8_t contrast)
{
	ssd1306_write_command(SSD1306_CMD_SET_CONTRAST_CONTROL_FOR_BANK0);
	ssd1306_write_command(contrast);
	return contrast;
}

/**
 * \brief ȗS߸ق𔽓]
 *
 * ̊֐OLED̑S߸ق𔽓]܂B
 *
 */
static inline void ssd1306_display_invert_enable(void)
{
	ssd1306_write_command(SSD1306_CMD_SET_INVERSE_DISPLAY);
}

/**
 * \brief ȗS߸ق̔]֎~
 *
 * ̊֐OLED̑S߸ق̔]֎~܂B
 *
 */
static inline void ssd1306_display_invert_disable(void)
{
	ssd1306_write_command(SSD1306_CMD_SET_NORMAL_DISPLAY);
}
//@}

//! \name 
//@{
void ssd1306_init(void);
//@}

/** @} */

#ifdef __cplusplus
}
#endif

#endif /* SSD1306_H_INCLUDED */
